<template>
  <div>
    <div v-if="showForm" class="form-conainer">
      <div class="row">
        <div class="col-9">
          <h4>
            <AlertTriangleIcon />
            You are revising your access request, please click submit once you
            have reviewed all the fields
          </h4>
        </div>
        <div class="col-2">
          <button class="btn btn-danger" @click="cancelAccessRequest()">
            <XIcon />
            Cancel Access Request
          </button>
        </div>
      </div>
      <div class="form-input">
        <div class="subheader mb-2">Project Title</div>
        <b-form-input
          v-model="formData.project_title.value"
          data-cy="input-title-create-project"
          placeholder="Title for the project"
          class="mb-1"
        >
        </b-form-input>
        <span v-if="formData.project_title.error" class="error-msg"
          >Please fill a project title</span
        >
      </div>

      <div class="form-input">
        <div class="subheader mb-2">Project Acronym</div>
        <b-form-input
          v-model="formData.project_acronym.value"
          class="form-control"
          placeholder="Acronym of project for the project"
        >
        </b-form-input>
        <span v-if="formData.project_acronym.error" class="error-msg"
          >Please fill a project acronym</span
        >
      </div>

      <div class="form-input">
        <div class="subheader mb-2">Project Summary</div>
        <textarea
          v-model="formData.project_summary.value"
          rows="4"
          class="form-control"
          placeholder="Summary of project"
        >
        </textarea>
        <span v-if="formData.project_summary.error" class="error-msg"
          >Please fill a project summary</span
        >
      </div>

      <div class="form-input">
        <div class="subheader mb-2">Project Objectives</div>
        <textarea
          v-model="formData.project_objectives.value"
          rows="4"
          class="form-control"
        >
        </textarea>
        <span v-if="formData.project_objectives.error" class="error-msg"
          >Please fill the project objectives</span
        >
      </div>

      <div class="form-input">
        <div class="subheader mb-2">Data Needed</div>
        <textarea
          v-model="formData.data_needed.value"
          rows="4"
          class="form-control"
        >
        </textarea>
        <span v-if="formData.data_needed.error" class="error-msg"
          >Please specify the data that you need</span
        >
      </div>

      <div
        v-for="dataset in accessRequest.datasets"
        :key="dataset.dataset.id"
        class="dataset-section card"
      >
        <h4>
          <b>{{ dataset.dataset.label }}</b> access details
          <span v-if="dataset.is_main" class="highlighter">(Main Dataset)</span>
        </h4>
        <table>
          <tr>
            <td width="250px">Access Type</td>
            <td>
              <select
                v-model="dataset.access_type"
                :class="`form-control col-2 access-type-dropdown access-type-dropdown-${dataset.dataset.label}`"
                :dataset="dataset.dataset.label"
                @change="accessTypeChanged($event, dataset)"
              >
                <option value="distant">Distant</option>
                <option value="physical">Physical</option>
              </select>
            </td>
          </tr>
          <tr v-if="dataset.access_type === 'physical'">
            <td>Host location</td>
            <td>
              <b-form-input
                v-model="dataset.host_location"
                class="form-control col-5"
              >
              </b-form-input>
            </td>
          </tr>
          <tr v-if="dataset.access_type === 'physical'">
            <td>Visit dates</td>
            <td>
              <b-form-input
                v-model="dataset.preferred_visit_dates"
                class="form-control col-5"
              >
              </b-form-input>
            </td>
          </tr>
        </table>
      </div>
      <span v-if="datasetErrors.length === 2">{{ datasetErrors[1] }}</span>

      <div class="subheader mb-2">CV</div>
      <div v-if="accessRequest.cv_url != null" class="message">
        You already have a CV uploaded for this access request. If you want to
        upload a new one, it will replace the one you have stored for this
        access request
        <b-button v-if="downloadUrl" :href="downloadUrl"
          >View uploaded CV</b-button
        >
      </div>
      <div class="col-3">
        <Dropzone
          id="dropzone"
          ref="myDropzone"
          class="upload upload-bordered h-100"
          :options="dropzoneOptions"
          :use-custom-slot="true"
          @vdropzone-file-added="onFileAdded"
          @vdropzone-error="onError"
          @vdropzone-success="onSuccess"
          @vdropzone-complete="onComplete"
          @vdropzone-removed-file="onRemoved"
        >
          <div class="upload-icon dz-clickable">
            <img
              alt="upload cv dropdown area"
              class="h-8 mt-2 mb-2"
              src="/illustrations/upload-datasets.svg"
              height="50"
            />
          </div>
          <p class="upload-subtitle text-muted dx-clickable">
            Drop file here or click to upload a new CV (pdf format)
          </p>
        </Dropzone>
      </div>

      <b-button class="submit-button" @click="submit()">Submit</b-button>
    </div>
    <div v-if="showForm === false" class="message">
      <AlertTriangleIcon />
      You cannot revise this access request.
      <a :href="`/access-request/${accessRequest.id}/details`">
        go back to details</a
      >
    </div>
  </div>
</template>

<script>
export default {
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      accessRequest: null,
      file: null,
      title: '',
      datasetErrors: [],
      showForm: true,
      downloadUrl: '',
      dropzoneOptions: {
        url: this.$config.ribaUrl,
        thumbnailWidth: 80,
        autoProcessQueue: false,
        addRemoveLinks: true,
        maxFiles: 1,
        dictDefaultMessage:
          'Drop file here or click to upload your CV (pdf format)',
        acceptedFiles: '.pdf',
      },
      formData: {
        project_title: {
          error: false,
          value: '',
        },
        project_acronym: {
          error: false,
          value: '',
        },
        project_summary: {
          error: false,
          value: '',
        },
        project_objectives: {
          error: false,
          value: '',
        },
        data_needed: {
          error: false,
          value: '',
        },
        selectedDatasets: [],
        cv_url: {
          value: '',
          error: false,
        },
      },
    };
  },
  async fetch() {
    this.accessRequest = await this.$nuxt.context.store.dispatch(
      'access_request/fetchAccessRequest',
      this.$nuxt.$route.params.id
    );

    function parseJwt(token) {
      return JSON.parse(Buffer.from(token.split('.')[1], 'base64').toString());
    }

    const token = this.$auth.strategy.token.get().split(' ');
    const decodedToken = parseJwt(token[1]);
    this.downloadUrl = `${this.$config.apiRoot}/access_requests/${this.accessRequest.id}/cv?access_token=${token[1]}`;

    if (
      this.accessRequest.should_be_revised === 0 ||
      this.accessRequest.user.email !== decodedToken.email
    ) {
      this.showForm = false;
    }

    this.formData.project_title.value = this.accessRequest.project_title;
    this.formData.project_summary.value = this.accessRequest.project_summary;
    this.formData.project_objectives.value =
      this.accessRequest.project_objectives;
    this.formData.data_needed.value = this.accessRequest.data_needed;
    this.formData.project_acronym.value = this.accessRequest.project_acronym;
    this.formData.selectedDatasets = this.accessRequest.datasets;
  },
  head() {
    return {
      title: 'Access Request Revision',
    };
  },
  mounted() {
    this.updateAccessType();
  },
  methods: {
    async submit() {
      Object.keys(this.formData).forEach((key) => {
        if (this.formData[key].error) {
          this.formData[key].error = false;
        }
      });
      this.datasetErrors = [];
      let totalErrors = 0;

      this.formData.files = [this.file];
      if (this.formData.project_title.value === '') {
        this.formData.project_title.error = true;
        totalErrors++;
      }

      if (this.formData.project_acronym.value === '') {
        this.formData.project_acronym.error = true;
        totalErrors++;
      }

      if (this.formData.project_summary.value === '') {
        this.formData.project_summary.error = true;
        totalErrors++;
      }

      if (this.formData.project_objectives.value === '') {
        this.formData.project_objectives.error = true;
        totalErrors++;
      }

      if (this.formData.data_needed.value === '') {
        this.formData.data_needed.error = true;
        totalErrors++;
      }

      if (totalErrors === 0) {
        const request = {
          project_title: this.formData.project_title.value,
          project_acronym: this.formData.project_acronym.value,
          project_summary: this.formData.project_summary.value,
          project_objectives: this.formData.project_objectives.value,
          data_needed: this.formData.data_needed.value,
          datasets: this.formData.selectedDatasets,
          id: this.accessRequest.id,
        };
        const res = await this.$nuxt.context.store.dispatch(
          'access_request/submitRevision',
          request
        );
        if (res) {
          if (this.file) {
            await this.$nuxt.context.store.dispatch('access_request/submitCv', {
              id: this.accessRequest.id,
              file: this.file,
            });
          }
          window.location = `/access-request/${res.id}/details`;
        }
      }
    },
    accessTypeChanged(event, dataset) {
      dataset.access_type = event.target.value;
      this.updateAccessType();
    },
    updateAccessType() {
      const inputs = document.getElementsByClassName('access-type-dropdown');
      const mainDataset = this.formData.selectedDatasets.find(
        (d) => d.is_main === 1
      );
      if (!mainDataset) {
        return;
      }

      if (mainDataset.access_type === 'distant') {
        this.formData.selectedDatasets.map((d) => (d.access_type = 'distant'));
        for (let i = 0; i < inputs.length; i++) {
          const datasetName = inputs[i].getAttribute('dataset');
          if (datasetName !== mainDataset.dataset.label) {
            inputs[i].setAttribute('disabled', 'disabled');
          } else {
            inputs[i].removeAttribute('disabled');
          }
        }
      } else {
        for (let i = 0; i < inputs.length; i++) {
          inputs[i].removeAttribute('disabled');
        }
      }
    },
    onFileAdded(e) {
      this.file = e;
      if (!this.title) {
        if (e.name.includes('.')) {
          this.title = e.name.split('.').slice(0, -1).join('.');
        } else {
          this.title = e.name;
        }
      }
    },
    async cancelAccessRequest() {
      await this.$bvModal
        .msgBoxConfirm('Are you sure you want to cancel this access request?', {
          id: 'delete-project-modal',
          title: 'Cancel Access Request?',
          okVariant: 'danger',
          okTitle: 'Yes',
          cancelTitle: 'No',
          footerClass: 'p-2',
          hideHeaderClose: false,
          centered: true,
        })
        // eslint-disable-next-line require-await
        .then(async (value) => {
          if (value) {
            const res = await this.$nuxt.context.store.dispatch(
              'access_request/cancelAccessRequest',
              this.accessRequest
            );
            if (res) {
              window.location = `/access-request/${res.id}/details`;
            }
          }
        });
    },
    onError() {},
    onSuccess() {},
    onComplete() {},
    onRemoved() {
      this.file = null;
      this.title = null;
    },
  },
};
</script>

<style scoped>
.dataset-section {
  margin: 5px 0 5px 0;
  border: 1px solid lightgray;
  border-radius: 2px;
  padding: 10px;
}

.submit-button {
  margin-top: 10px;
  float: right;
}

.error-msg {
  color: rgb(235, 64, 64);
}

.form-input {
  margin-bottom: 20px;
}

table td {
  /* padding: 10px; */
}

.highlighter {
  color: red;
}

.message {
  padding: 10px;
  background-color: #ffc150;
  border-radius: 5px;
  margin-bottom: 5px;
}
</style>
